]> git.madduck.net Git - code/myrepos.git/blob - mr

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

ok, it's clean enough now
[code/myrepos.git] / mr
1 #!/usr/bin/perl
2
3 #man{{{
4
5 =head1 NAME
6
7 mr - a Multiple Repository management tool
8
9 =head1 SYNOPSIS
10
11 B<mr> [options] checkout
12
13 B<mr> [options] update
14
15 B<mr> [options] status
16
17 B<mr> [options] commit [-m "message"]
18
19 B<mr> [options] diff
20
21 B<mr> [options] log
22
23 B<mr> [options] register [repository]
24
25 B<mr> [options] config section ["parameter=[value]" ...]
26
27 B<mr> [options] action [params ...]
28
29 =head1 DESCRIPTION
30
31 B<mr> is a Multiple Repository management tool. It can checkout, update, or
32 perform other actions on a set of repositories as if they were one combined
33 respository. It supports any combination of subversion, git, cvs, mecurial,
34 bzr and darcs repositories, and support for other revision control systems can
35 easily be added.
36
37 B<mr> cds into and operates on all registered repositories at or below your
38 working directory. Or, if you are in a subdirectory of a repository that
39 contains no other registered repositories, it will stay in that directory,
40 and work on only that repository,
41
42 These predefined commands should be fairly familiar to users of any revision
43 control system:
44
45 =over 4
46
47 =item checkout (or co)
48
49 Checks out any repositories that are not already checked out.
50
51 =item update
52
53 Updates each repository from its configured remote repository.
54
55 If a repository isn't checked out yet, it will first check it out.
56
57 =item status
58
59 Displays a status report for each repository, showing what
60 uncommitted changes are present in the repository.
61
62 =item commit (or ci)
63
64 Commits changes to each repository. (By default, changes are pushed to the
65 remote repository too, when using distributed systems like git.)
66
67 The optional -m parameter allows specifying a commit message.
68
69 =item diff
70
71 Show a diff of uncommitted changes.
72
73 =item log
74
75 Show the commit log.
76
77 =back
78
79 These commands are also available:
80
81 =over 4
82
83 =item list (or ls)
84
85 List the repositories that mr will act on.
86
87 =item register
88
89 Register an existing repository in a mrconfig file. By default, the
90 repository in the current directory is registered, or you can specify a
91 directory to register.
92
93 The mrconfig file that is modified is chosen by either the -c option, or by
94 looking for the closest known one at or below the current directory.
95
96 =item config
97
98 Adds, modifies, removes, or prints a value from a mrconfig file. The next
99 parameter is the name of the section the value is in. To add or modify
100 values, use one or more instances of "parameter=value". Use "parameter=" to
101 remove a parameter. Use just "parameter" to get the value of a parameter.
102
103 For example, to add (or edit) a repository in src/foo:
104
105   mr config src/foo checkout="svn co svn://example.com/foo/trunk foo"
106
107 To show the command that mr uses to update the repository in src/foo:
108
109   mr config src/foo update
110
111 To see the built-in library of shell functions contained in mr:
112
113   mr config DEFAULT lib
114
115 The ~/.mrconfig file is used by default. To use a different config file,
116 use the -c option.
117
118 =item help
119
120 Displays this help.
121
122 =back
123
124 Actions can be abbreviated to any unambiguous subsctring, so
125 "mr st" is equivilant to "mr status", and "mr up" is equivilant to "mr
126 update"
127
128 Additional parameters can be passed to most commands, and are passed on
129 unchanged to the underlying revision control system. This is mostly useful
130 if the repositories mr will act on all use the same revision control
131 system.
132
133 =head1 OPTIONS
134
135 =over 4
136
137 =item -d directory
138
139 Specifies the topmost directory that B<mr> should work in. The default is
140 the current working directory.
141
142 =item -c mrconfig
143
144 Use the specified mrconfig file. The default is B<~/.mrconfig>
145
146 =item -v
147
148 Be verbose.
149
150 =item -s
151
152 Expand the statistics line displayed at the end to include information
153 about exactly which repositories failed and were skipped, if any.
154
155 =item -n
156
157 Just operate on the repository for the current directory, do not 
158 recurse into deeper repositories.
159
160 =item -j number
161
162 Run the specified number of jobs in parallel. This can greatly speed up
163 operations such as updates. It is not recommended for interactive
164 operations.
165
166 =back
167
168 =head1 FILES
169
170 B<mr> is configured by .mrconfig files. It starts by reading the .mrconfig
171 file in your home directory, and this can in turn chain load .mrconfig files
172 from repositories.
173
174 Here is an example .mrconfig file:
175
176   [src]
177   checkout = svn co svn://svn.example.com/src/trunk src
178   chain = true
179
180   [src/linux-2.6]
181   checkout = git clone git://git.kernel.org/pub/scm/linux/kernel/git/torvalds/linux-2.6.git &&
182         cd linux-2.6 &&
183         git checkout -b mybranch origin/master
184
185 The .mrconfig file uses a variant of the INI file format. Lines starting with
186 "#" are comments. Values can be continued to the following line by
187 indenting the line with whitespace.
188
189 The "DEFAULT" section allows setting default values for the sections that
190 come after it.
191
192 The "ALIAS" section allows adding aliases for actions. Each parameter
193 is an alias, and its value is the action to use.
194
195 All other sections add repositories. The section header specifies the
196 directory where the repository is located. This is relative to the directory
197 that contains the mrconfig file, but you can also choose to use absolute
198 paths.
199
200 Within a section, each parameter defines a shell command to run to handle a
201 given action. mr contains default handlers for "update", "status",
202 "commit", and other standard actions. Normally you only need to specify what
203 to do for "checkout".
204
205 Note that these shell commands are run in a "set -e" shell
206 environment, where any additional parameters you pass are available in
207 "$@". The "checkout" command is run in the parent of the repository
208 directory, since the repository isn't checked out yet. All other commands
209 are run inside the repository, though not necessarily at the top of it.
210
211 The "MR_REPO" environment variable is set to the path to the top of the
212 repository. (For the "register" action, "MR_REPO" is instead set to the 
213 basename of the directory that should be created when checking the
214 repository out.)
215
216 The "MR_CONFIG" environment variable is set to the .mrconfig file
217 that defines the repo being acted on, or, if the repo is not yet in a config
218 file, the .mrconfig file that should be modified to register the repo.
219
220 A few parameters have special meanings:
221
222 =over 4
223
224 =item skip
225
226 If the "skip" parameter is set and its command returns true, then B<mr>
227 will skip acting on that repository. The command is passed the action
228 name in $1.
229
230 Here are two examples. The first skips the repo unless
231 mr is run by joey. The second uses the hours_since function
232 (included in mr's built-in library) to skip updating the repo unless it's
233 been at least 12 hours since the last update.
234
235   skip = test $(whoami) != joey
236   skip = [ "$1" = update ] && ! hours_since "$1" 12
237
238 =item order
239
240 The "order" parameter can be used to override the default ordering of
241 repositories. The default order value is 10. Use smaller values to make
242 repositories be processed earlier, and larger values to make repositories
243 be processed later.
244
245 Note that if a repository is located in a subdirectory of another
246 repository, ordering it to be processed earlier is not recommended.
247
248 =item chain
249
250 If the "chain" parameter is set and its command returns true, then B<mr>
251 will try to load a .mrconfig file from the root of the repository. (You
252 should avoid chaining from repositories with untrusted committers.)
253
254 =item include
255
256 If the "include" parameter is set, its command is ran, and should output
257 additional mrconfig file content. The content is included as if it were
258 part of the including file.
259
260 Unlike all other parameters, this parameter does not need to be placed
261 within a section.
262
263 =item lib
264
265 The "lib" parameter can specify some shell code that will be run before each
266 command, this can be a useful way to define shell functions for other commands
267 to use.
268
269 =back
270
271 When looking for a command to run for a given action, mr first looks for
272 a parameter with the same name as the action. If that is not found, it
273 looks for a parameter named "rcs_action" (substituting in the name of the
274 revision control system and the action). The name of the revision control
275 system is itself determined by running each defined "rcs_test" action,
276 until one succeeds.
277
278 Internally, mr has settings for "git_update", "svn_update", etc. To change
279 the action that is performed for a given revision control system, you can
280 override these rcs specific actions. To add a new revision control system,
281 you can just add rcs specific actions for it.
282
283 =head1 AUTHOR
284
285 Copyright 2007 Joey Hess <joey@kitenet.net>
286
287 Licensed under the GNU GPL version 2 or higher.
288
289 http://kitenet.net/~joey/code/mr/
290
291 =cut
292
293 #}}}
294
295 use warnings;
296 use strict;
297 use Getopt::Long;
298 use Cwd qw(getcwd abs_path);
299 use POSIX "WNOHANG";
300 use constant {
301         OK => 0,
302         FAILED => 1,
303         SKIPPED => 2,
304         ABORT => 3,
305 };
306
307 my $config_overridden=0;
308 my $verbose=0;
309 my $stats=0;
310 my $no_recurse=0;
311 my $no_chdir=0;
312 my $jobs=1;
313 my $directory=getcwd();
314
315 my %config;
316 my %configfiles;
317 my %knownactions;
318 my %alias;
319 my (@ok, @failed, @skipped);
320
321 main();
322
323 sub dispatch { #{{{
324         my $action=shift;
325
326         # actions that do not operate on all repos
327         if ($action eq 'help') {
328                 help(@ARGV);
329         }
330         elsif ($action eq 'config') {
331                 config(@ARGV);
332         }
333         elsif ($action eq 'register') {
334                 register(@ARGV);
335         }
336
337         if ($jobs > 1) {
338                 mrs($action, selectrepos());
339         }
340         else {
341                 foreach my $repo (selectrepos()) {
342                         record($repo, action($action, @$repo));
343                 }
344         }
345 } #}}}
346
347 sub rcs_test { #{{{
348         my ($action, $dir, $topdir, $subdir) = @_;
349
350         my $test="set -e\n";
351         foreach my $rcs_test (
352                         sort {
353                                 length $a <=> length $b 
354                                           ||
355                                        $a cmp $b
356                         } grep { /_test$/ } keys %{$config{$topdir}{$subdir}}) {
357                 my ($rcs)=$rcs_test=~/(.*)_test/;
358                 $test="my_$rcs_test() {\n$config{$topdir}{$subdir}{$rcs_test}\n}\n".$test;
359                 $test.="if my_$rcs_test; then echo $rcs; fi\n";
360         }
361         $test=$config{$topdir}{$subdir}{lib}."\n".$test
362                 if exists $config{$topdir}{$subdir}{lib};
363         
364         print "mr $action: running rcs test >>$test<<\n" if $verbose;
365         my $rcs=`$test`;
366         chomp $rcs;
367         if (! length $rcs) {
368                 return undef;
369         }
370         else {
371                 return $rcs;
372         }
373 } #}}}
374         
375 sub findcommand { #{{{
376         my ($action, $dir, $topdir, $subdir) = @_;
377         
378         if (exists $config{$topdir}{$subdir}{$action}) {
379                 return $config{$topdir}{$subdir}{$action};
380         }
381
382         my $rcs=rcs_test(@_);
383
384         if (defined $rcs && 
385             exists $config{$topdir}{$subdir}{$rcs."_".$action}) {
386                 return $config{$topdir}{$subdir}{$rcs."_".$action};
387         }
388         else {
389                 return undef;
390         }
391 } #}}}
392
393 sub action { #{{{
394         my ($action, $dir, $topdir, $subdir) = @_;
395
396         $ENV{MR_CONFIG}=$configfiles{$topdir};
397         my $lib=exists $config{$topdir}{$subdir}{lib} ?
398                        $config{$topdir}{$subdir}{lib}."\n" : "";
399
400         if ($action eq 'checkout') {
401                 if (-d $dir) {
402                         print "mr $action: $dir already exists, skipping checkout\n" if $verbose;
403                         return SKIPPED;
404                 }
405
406                 $dir=~s/^(.*)\/[^\/]+\/?$/$1/;
407
408                 if (! -d $dir) {
409                         print "mr $action: creating parent directory $dir\n" if $verbose;
410                         system("mkdir", "-p", $dir);
411                 }
412         }
413         elsif ($action =~ /update/) {
414                 if (! -d $dir) {
415                         return action("checkout", $dir, $topdir, $subdir);
416                 }
417         }
418
419         $ENV{MR_REPO}=$dir;
420
421         my $skiptest=findcommand("skip", $dir, $topdir, $subdir);
422         my $command=findcommand($action, $dir, $topdir, $subdir);
423
424         if (defined $skiptest) {
425                 my $test="set -e;".$lib.
426                         "my_action(){ $skiptest\n }; my_action '$action'";
427                 print "mr $action: running skip test >>$test<<\n" if $verbose;
428                 my $ret=system($test);
429                 if ($ret != 0) {
430                         if (($? & 127) == 2) {
431                                 print STDERR "mr $action: interrupted\n";
432                                 return ABORT;
433                         }
434                         elsif ($? & 127) {
435                                 print STDERR "mr $action: skip test received signal ".($? & 127)."\n";
436                                 return ABORT;
437                         }
438                 }
439                 if ($ret >> 8 == 0) {
440                         print "mr $action: $dir skipped per config file\n" if $verbose;
441                         return SKIPPED;
442                 }
443         }
444         
445         if (! $no_chdir && ! chdir($dir)) {
446                 print STDERR "mr $action: failed to chdir to $dir: $!\n";
447                 return FAILED;
448         }
449         elsif (! defined $command) {
450                 my $rcs=rcs_test(@_);
451                 if (! defined $rcs) {
452                         print STDERR "mr $action: unknown repository type and no defined $action command for $topdir$subdir\n";
453                         return FAILED;
454                 }
455                 else {
456                         print STDERR "mr $action: no defined $action command for $rcs repository $topdir$subdir, skipping\n";
457                         return SKIPPED;
458                 }
459         }
460         else {
461                 if (! $no_chdir) {
462                         print "mr $action: $topdir$subdir\n";
463                 }
464                 else {
465                         my $s=$directory;
466                         $s=~s/^\Q$topdir$subdir\E\/?//;
467                         print "mr $action: $topdir$subdir (in subdir $s)\n";
468                 }
469                 $command="set -e; ".$lib.
470                         "my_action(){ $command\n }; my_action ".
471                         join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
472                 print "mr $action: running >>$command<<\n" if $verbose;
473                 my $ret=system($command);
474                 if ($ret != 0) {
475                         if (($? & 127) == 2) {
476                                 print STDERR "mr $action: interrupted\n";
477                                 return ABORT;
478                         }
479                         elsif ($? & 127) {
480                                 print STDERR "mr $action: received signal ".($? & 127)."\n";
481                                 return ABORT;
482                         }
483                         print STDERR "mr $action: failed ($ret)\n" if $verbose;
484                         if ($ret >> 8 != 0) {
485                                 print STDERR "mr $action: command failed\n";
486                         }
487                         elsif ($ret != 0) {
488                                 print STDERR "mr $action: command died ($ret)\n";
489                         }
490                         return FAILED;
491                 }
492                 else {
493                         if ($action eq 'checkout' && ! -d $dir) {
494                                 print STDERR "mr $action: $dir missing after checkout\n";;
495                                 return FAILED;
496                         }
497
498                         return OK;
499                 }
500         }
501 } #}}}
502
503 # run actions on multiple repos, in parallel
504 sub mrs { #{{{
505         my $action=shift;
506         my @repos=@_;
507
508         $| = 1;
509         my @active;
510         my @fhs;
511         my @out;
512         my $running=0;
513         while (@fhs or @repos) {
514                 while ($running < $jobs && @repos) {
515                         $running++;
516                         my $repo = shift @repos;
517                         pipe(my $outfh, CHILD_STDOUT);
518                         pipe(my $errfh, CHILD_STDERR);
519                         my $pid;
520                         unless ($pid = fork) {
521                                 die "mr $action: cannot fork: $!" unless defined $pid;
522                                 open(STDOUT, ">&CHILD_STDOUT") || die "mr $action cannot reopen stdout: $!";
523                                 open(STDERR, ">&CHILD_STDERR") || die "mr $action cannot reopen stderr: $!";
524                                 close CHILD_STDOUT;
525                                 close CHILD_STDERR;
526                                 close $outfh;
527                                 close $errfh;
528                                 exit action($action, @$repo);
529                         }
530                         close CHILD_STDOUT;
531                         close CHILD_STDERR;
532                         push @active, [$pid, $repo];
533                         push @fhs, [$outfh, $errfh];
534                         push @out, ['',     ''];
535                 }
536                 my ($rin, $rout) = ('','');
537                 my $nfound;
538                 foreach my $fh (@fhs) {
539                         next unless defined $fh;
540                         vec($rin, fileno($fh->[0]), 1) = 1 if defined $fh->[0];
541                         vec($rin, fileno($fh->[1]), 1) = 1 if defined $fh->[1];
542                 }
543                 $nfound = select($rout=$rin, undef, undef, 1);
544                 foreach my $channel (0, 1) {
545                         foreach my $i (0..$#fhs) {
546                                 next unless defined $fhs[$i];
547                                 my $fh = $fhs[$i][$channel];
548                                 next unless defined $fh;
549                                 if (vec($rout, fileno($fh), 1) == 1) {
550                                         my $r = '';
551                                         if (sysread($fh, $r, 1024) == 0) {
552                                                 close($fh);
553                                                 $fhs[$i][$channel] = undef;
554                                                 if (! defined $fhs[$i][0] &&
555                                                     ! defined $fhs[$i][1]) {
556                                                         waitpid($active[$i][0], 0);
557                                                         print STDOUT $out[$i][0];
558                                                         print STDERR $out[$i][1];
559                                                         record($active[$i][1], $? >> 8);
560                                                         splice(@fhs, $i, 1);
561                                                         splice(@active, $i, 1);
562                                                         splice(@out, $i, 1);
563                                                         $running--;
564                                                 }
565                                         }
566                                         $out[$i][$channel] .= $r;
567                                 }
568                         }
569                 }
570         }
571 } #}}}
572
573 sub record { #{{{
574         my $dir=shift()->[0];
575         my $ret=shift;
576
577         if ($ret == OK) {
578                 push @ok, $dir;
579                 print "\n";
580         }
581         elsif ($ret == FAILED) {
582                 push @failed, $dir;
583                 print "\n";
584         }
585         elsif ($ret == SKIPPED) {
586                 push @skipped, $dir;
587         }
588         elsif ($ret == ABORT) {
589                 exit 1;
590         }
591         else {
592                 die "unknown exit status $ret";
593         }
594 } #}}}
595
596 sub showstats { #{{{
597         my $action=shift;
598         if (! @ok && ! @failed && ! @skipped) {
599                 die "mr $action: no repositories found to work on\n";
600         }
601         print "mr $action: finished (".join("; ",
602                 showstat($#ok+1, "ok", "ok"),
603                 showstat($#failed+1, "failed", "failed"),
604                 showstat($#skipped+1, "skipped", "skipped"),
605         ).")\n";
606         if ($stats) {
607                 if (@skipped) {
608                         print "mr $action: (skipped: ".join(" ", @skipped).")\n";
609                 }
610                 if (@failed) {
611                         print STDERR "mr $action: (failed: ".join(" ", @failed).")\n";
612                 }
613         }
614 } #}}}
615
616 sub showstat { #{{{
617         my $count=shift;
618         my $singular=shift;
619         my $plural=shift;
620         if ($count) {
621                 return "$count ".($count > 1 ? $plural : $singular);
622         }
623         return;
624 } #}}}
625
626 # an ordered list of repos
627 sub repolist { #{{{
628         my @list;
629         foreach my $topdir (sort keys %config) {
630                 foreach my $subdir (sort keys %{$config{$topdir}}) {
631                         push @list, {
632                                 topdir => $topdir,
633                                 subdir => $subdir,
634                                 order => $config{$topdir}{$subdir}{order},
635                         };
636                 }
637         }
638         return sort {
639                 $a->{order}  <=> $b->{order}
640                              ||
641                 $a->{topdir} cmp $b->{topdir}
642                              ||
643                 $a->{subdir} cmp $b->{subdir}
644         } @list;
645 } #}}}
646
647 # figure out which repos to act on
648 sub selectrepos { #{{{
649         my @repos;
650         foreach my $repo (repolist()) {
651                 my $topdir=$repo->{topdir};
652                 my $subdir=$repo->{subdir};
653
654                 next if $subdir eq 'DEFAULT';
655                 my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
656                 my $d=$directory;
657                 $dir.="/" unless $dir=~/\/$/;
658                 $d.="/" unless $d=~/\/$/;
659                 next if $no_recurse && $d ne $dir;
660                 next if $dir ne $d && $dir !~ /^\Q$d\E/;
661                 push @repos, [$dir, $topdir, $subdir];
662         }
663         if (! @repos) {
664                 # fallback to find a leaf repo
665                 foreach my $repo (reverse repolist()) {
666                         my $topdir=$repo->{topdir};
667                         my $subdir=$repo->{subdir};
668                         
669                         next if $subdir eq 'DEFAULT';
670                         my $dir=($subdir =~/^\//) ? $subdir : $topdir.$subdir;
671                         my $d=$directory;
672                         $dir.="/" unless $dir=~/\/$/;
673                         $d.="/" unless $d=~/\/$/;
674                         if ($d=~/^\Q$dir\E/) {
675                                 push @repos, [$dir, $topdir, $subdir];
676                                 last;
677                         }
678                 }
679                 $no_chdir=1;
680         }
681         return @repos;
682 } #}}}
683
684 my %loaded;
685 sub loadconfig { #{{{
686         my $f=shift;
687
688         my @toload;
689
690         my $in;
691         my $dir;
692         if (ref $f eq 'GLOB') {
693                 $dir="";
694                 $in=$f; 
695         }
696         else {
697                 if (! -e $f) {
698                         return;
699                 }
700
701                 my $absf=abs_path($f);
702                 if ($loaded{$absf}) {
703                         return;
704                 }
705                 $loaded{$absf}=1;
706
707                 ($dir)=$f=~/^(.*\/)[^\/]+$/;
708                 if (! defined $dir) {
709                         $dir=".";
710                 }
711                 $dir=abs_path($dir)."/";
712                 
713                 if (! exists $configfiles{$dir}) {
714                         $configfiles{$dir}=$f;
715                 }
716
717                 # copy in defaults from first parent
718                 my $parent=$dir;
719                 while ($parent=~s/^(.*\/)[^\/]+\/?$/$1/) {
720                         if ($parent eq '/') {
721                                 $parent="";
722                         }
723                         if (exists $config{$parent} &&
724                             exists $config{$parent}{DEFAULT}) {
725                                 $config{$dir}{DEFAULT}={ %{$config{$parent}{DEFAULT}} };
726                                 last;
727                         }
728                 }
729                 
730                 print "mr: loading config $f\n" if $verbose;
731                 open($in, "<", $f) || die "mr: open $f: $!\n";
732         }
733         my @lines=<$in>;
734         close $in;
735
736         my $section;
737         my $line=0;
738         while (@lines) {
739                 $_=shift @lines;
740                 $line++;
741                 chomp;
742                 next if /^\s*\#/ || /^\s*$/;
743                 if (/^\[([^\]]*)\]\s*$/) {
744                         $section=$1;
745                 }
746                 elsif (/^(\w+)\s*=\s*(.*)/) {
747                         my $parameter=$1;
748                         my $value=$2;
749
750                         # continued value
751                         while (@lines && $lines[0]=~/^\s(.+)/) {
752                                 shift(@lines);
753                                 $line++;
754                                 $value.="\n$1";
755                                 chomp $value;
756                         }
757
758                         if ($parameter eq "include") {
759                                 print "mr: including output of \"$value\"\n" if $verbose;
760                                 unshift @lines, `$value`;
761                                 next;
762                         }
763
764                         if (! defined $section) {
765                                 die "$f line $.: parameter ($parameter) not in section\n";
766                         }
767                         if ($section ne 'ALIAS' &&
768                             ! exists $config{$dir}{$section} &&
769                             exists $config{$dir}{DEFAULT}) {
770                                 # copy in defaults
771                                 $config{$dir}{$section}={ %{$config{$dir}{DEFAULT}} };
772                         }
773                         if ($section eq 'ALIAS') {
774                                 $alias{$parameter}=$value;
775                         }
776                         elsif ($parameter eq 'lib') {
777                                 $config{$dir}{$section}{lib}.=$value."\n";
778                         }
779                         else {
780                                 $config{$dir}{$section}{$parameter}=$value;
781                                 if ($parameter =~ /.*_(.*)/) {
782                                         $knownactions{$1}=1;
783                                 }
784                                 else {
785                                         $knownactions{$parameter}=1;
786                                 }
787                                 if ($parameter eq 'chain' &&
788                                     length $dir && $section ne "DEFAULT" &&
789                                     -e $dir.$section."/.mrconfig") {
790                                         my $ret=system($value);
791                                         if ($ret != 0) {
792                                                 if (($? & 127) == 2) {
793                                                         print STDERR "mr: chain test interrupted\n";
794                                                         exit 2;
795                                                 }
796                                                 elsif ($? & 127) {
797                                                         print STDERR "mr: chain test received signal ".($? & 127)."\n";
798                                                 }
799                                         }
800                                         else {
801                                                 push @toload, $dir.$section."/.mrconfig";
802                                         }
803                                 }
804                         }
805                 }
806                 else {
807                         die "$f line $line: parse error\n";
808                 }
809         }
810
811         foreach (@toload) {
812                 loadconfig($_);
813         }
814 } #}}}
815
816 sub modifyconfig { #{{{
817         my $f=shift;
818         # the section to modify or add
819         my $targetsection=shift;
820         # fields to change in the section
821         # To remove a field, set its value to "".
822         my %changefields=@_;
823
824         my @lines;
825         my @out;
826
827         if (-e $f) {
828                 open(my $in, "<", $f) || die "mr: open $f: $!\n";
829                 @lines=<$in>;
830                 close $in;
831         }
832
833         my $formatfield=sub {
834                 my $field=shift;
835                 my @value=split(/\n/, shift);
836
837                 return "$field = ".shift(@value)."\n".
838                         join("", map { "\t$_\n" } @value);
839         };
840         my $addfields=sub {
841                 my @blanks;
842                 while ($out[$#out] =~ /^\s*$/) {
843                         unshift @blanks, pop @out;
844                 }
845                 foreach my $field (sort keys %changefields) {
846                         if (length $changefields{$field}) {
847                                 push @out, "$field = $changefields{$field}\n";
848                                 delete $changefields{$field};
849                         }
850                 }
851                 push @out, @blanks;
852         };
853
854         my $section;
855         while (@lines) {
856                 $_=shift(@lines);
857
858                 if (/^\s*\#/ || /^\s*$/) {
859                         push @out, $_;
860                 }
861                 elsif (/^\[([^\]]*)\]\s*$/) {
862                         if (defined $section && 
863                             $section eq $targetsection) {
864                                 $addfields->();
865                         }
866
867                         $section=$1;
868
869                         push @out, $_;
870                 }
871                 elsif (/^(\w+)\s*=\s(.*)/) {
872                         my $parameter=$1;
873                         my $value=$2;
874
875                         # continued value
876                         while (@lines && $lines[0]=~/^\s(.+)/) {
877                                 shift(@lines);
878                                 $value.="\n$1";
879                                 chomp $value;
880                         }
881
882                         if ($section eq $targetsection) {
883                                 if (exists $changefields{$parameter}) {
884                                         if (length $changefields{$parameter}) {
885                                                 $value=$changefields{$parameter};
886                                         }
887                                         delete $changefields{$parameter};
888                                 }
889                         }
890
891                         push @out, $formatfield->($parameter, $value);
892                 }
893         }
894
895         if (defined $section && 
896             $section eq $targetsection) {
897                 $addfields->();
898         }
899         elsif (%changefields) {
900                 push @out, "\n[$targetsection]\n";
901                 foreach my $field (sort keys %changefields) {
902                         if (length $changefields{$field}) {
903                                 push @out, $formatfield->($field, $changefields{$field});
904                         }
905                 }
906         }
907
908         open(my $out, ">", $f) || die "mr: write $f: $!\n";
909         print $out @out;
910         close $out;     
911 } #}}}
912         
913 sub help { #{{{
914         exec($config{''}{DEFAULT}{help}) || die "exec: $!";
915 } #}}}
916         
917 sub config { #{{{
918         if (@_ < 2) {
919                 die "mr config: not enough parameters\n";
920         }
921         my $section=shift;
922         if ($section=~/^\//) {
923                 # try to convert to a path relative to the config file
924                 my ($dir)=$ENV{MR_CONFIG}=~/^(.*\/)[^\/]+$/;
925                 $dir=abs_path($dir);
926                 $dir.="/" unless $dir=~/\/$/;
927                 if ($section=~/^\Q$dir\E(.*)/) {
928                         $section=$1;
929                 }
930         }
931         my %changefields;
932         foreach (@_) {
933                 if (/^([^=]+)=(.*)$/) {
934                         $changefields{$1}=$2;
935                 }
936                 else {
937                         my $found=0;
938                         foreach my $topdir (sort keys %config) {
939                                 if (exists $config{$topdir}{$section} &&
940                                     exists $config{$topdir}{$section}{$_}) {
941                                         print $config{$topdir}{$section}{$_}."\n";
942                                         $found=1;
943                                         last if $section eq 'DEFAULT';
944                                 }
945                         }
946                         if (! $found) {
947                                 die "mr config: $section $_ not set\n";
948                         }
949                 }
950         }
951         modifyconfig($ENV{MR_CONFIG}, $section, %changefields) if %changefields;
952         exit 0;
953 } #}}}
954
955 sub register { #{{{
956         if (! $config_overridden) {
957                 # Find the closest known mrconfig file to the current
958                 # directory.
959                 $directory.="/" unless $directory=~/\/$/;
960                 foreach my $topdir (reverse sort keys %config) {
961                         next unless length $topdir;
962                         if ($directory=~/^\Q$topdir\E/) {
963                                 $ENV{MR_CONFIG}=$configfiles{$topdir};
964                                 $directory=$topdir;
965                                 last;
966                         }
967                 }
968         }
969         if (@ARGV) {
970                 my $subdir=shift @ARGV;
971                 if (! chdir($subdir)) {
972                         print STDERR "mr register: failed to chdir to $subdir: $!\n";
973                 }
974         }
975
976         $ENV{MR_REPO}=getcwd();
977         my $command=findcommand("register", $ENV{MR_REPO}, $directory, 'DEFAULT');
978         if (! defined $command) {
979                 die "mr register: unknown repository type\n";
980         }
981
982         $ENV{MR_REPO}=~s/.*\/(.*)/$1/;
983         $command="set -e; ".$config{$directory}{DEFAULT}{lib}."\n".
984                 "my_action(){ $command\n }; my_action ".
985                 join(" ", map { s/\//\/\//g; s/"/\"/g; '"'.$_.'"' } @ARGV);
986         print "mr register: running >>$command<<\n" if $verbose;
987         exec($command) || die "exec: $!";
988 } #}}}
989
990 # alias expansion and command stemming
991 sub expandaction { #{{{
992         my $action=shift;
993         if (exists $alias{$action}) {
994                 $action=$alias{$action};
995         }
996         if (! exists $knownactions{$action}) {
997                 my @matches = grep { /^\Q$action\E/ }
998                         keys %knownactions, keys %alias;
999                 if (@matches == 1) {
1000                         $action=$matches[0];
1001                 }
1002                 elsif (@matches == 0) {
1003                         die "mr: unknown action \"$action\" (known actions: ".
1004                                 join(", ", sort keys %knownactions).")\n";
1005                 }
1006                 else {
1007                         die "mr: ambiguous action \"$action\" (matches: ".
1008                                 join(", ", @matches).")\n";
1009                 }
1010         }
1011         return $action;
1012 } #}}}
1013
1014 sub getopts { #{{{
1015         Getopt::Long::Configure("no_permute");
1016         my $result=GetOptions(
1017                 "d|directory=s" => sub { $directory=abs_path($_[1]) },
1018                 "c|config=s" => sub { $ENV{MR_CONFIG}=$_[1]; $config_overridden=1 },
1019                 "v|verbose" => \$verbose,
1020                 "s|stats" => \$stats,
1021                 "n|no-recurse" => \$no_recurse,
1022                 "j|jobs=i" => \$jobs,
1023         );
1024         if (! $result || @ARGV < 1) {
1025                 die("Usage: mr [-d directory] action [params ...]\n".
1026                     "(Use mr help for man page.)\n");
1027         }
1028 } #}}}
1029
1030 sub init { #{{{
1031         $SIG{INT}=sub {
1032                 print STDERR "mr: interrupted\n";
1033                 exit 2;
1034         };
1035         
1036         $ENV{MR_CONFIG}="$ENV{HOME}/.mrconfig";
1037
1038         # This can happen if it's run in a directory that was removed
1039         # or other strangeness.
1040         if (! defined $directory) {
1041                 die("mr: failed to determine working directory\n");
1042         }
1043         # Make sure MR_CONFIG is an absolute path, but don't use abs_path since
1044         # the config file might be a symlink to elsewhere, and the directory it's
1045         # in is significant.
1046         if ($ENV{MR_CONFIG} !~ /^\//) {
1047                 $ENV{MR_CONFIG}=getcwd()."/".$ENV{MR_CONFIG};
1048         }
1049         # Try to set MR_PATH to the path to the program.
1050         eval {
1051                 use FindBin qw($Bin $Script);
1052                 $ENV{MR_PATH}=$Bin."/".$Script;
1053         };
1054 } #}}}
1055
1056 sub main { #{{{
1057         getopts();
1058         init();
1059         loadconfig(\*DATA);
1060         loadconfig($ENV{MR_CONFIG});
1061         #use Data::Dumper; print Dumper(\%config);
1062
1063         my $action=expandaction(shift @ARGV);
1064         dispatch($action);
1065         showstats($action);
1066
1067         if (@failed) {
1068                 exit 1;
1069         }
1070         elsif (! @ok && @skipped) {
1071                 exit 1;
1072         }
1073         else {
1074                 exit 0;
1075         }
1076 } #}}}
1077
1078 # Finally, some useful actions that mr knows about by default.
1079 # These can be overridden in ~/.mrconfig.
1080 #DATA{{{
1081 __DATA__
1082 [ALIAS]
1083 co = checkout
1084 ci = commit
1085 ls = list
1086
1087 [DEFAULT]
1088 order = 10
1089 lib =
1090         error() {
1091                 echo "mr: $@" >&2
1092                 exit 1
1093         }
1094         warning() {
1095                 echo "mr (warning): $@" >&2
1096         }
1097         info() {
1098                 echo "mr: $@" >&2
1099         }
1100         hours_since() {
1101                 if [ -z "$1" ] || [ -z "$2" ]; then
1102                         error "mr: usage: hours_since action num"
1103                 fi
1104                 for dir in .git .svn .bzr CVS .hg _darcs; do
1105                         if [ -e "$MR_REPO/$dir" ]; then
1106                                 flagfile="$MR_REPO/$dir/.mr_last$1"
1107                                 break
1108                         fi
1109                 done
1110                 if [ -z "$flagfile" ]; then
1111                         error "cannot determine flag filename"
1112                 fi
1113                 delta=$(perl -wle 'print -f shift() ? int((-M _) * 24) : 9999' "$flagfile")
1114                 if [ "$delta" -lt "$2" ]; then
1115                         exit 0
1116                 else
1117                         touch "$flagfile"
1118                         exit 1
1119                 fi
1120         }
1121
1122 svn_test = test -d "$MR_REPO"/.svn
1123 git_test = test -d "$MR_REPO"/.git
1124 bzr_test = test -d "$MR_REPO"/.bzr
1125 cvs_test = test -d "$MR_REPO"/CVS
1126 hg_test  = test -d "$MR_REPO"/.hg
1127 darcs_test = test -d "$MR_REPO"/_darcs
1128 git_bare_test =
1129         test -d "$MR_REPO"/refs/heads && test -d "$MR_REPO"/refs/tags &&
1130         test -d "$MR_REPO"/objects && test -f "$MR_REPO"/config &&
1131         test "$(GIT_CONFIG="$MR_REPO"/config git-config --get core.bare)" = true
1132
1133 svn_update = svn update "$@"
1134 git_update = if [ "$@" ]; then git pull "$@"; else git pull -t origin master; fi
1135 bzr_update = bzr merge "$@"
1136 cvs_update = cvs update "$@"
1137 hg_update  = hg pull "$@" && hg update "$@"
1138 darcs_update = darcs pull -a "$@"
1139
1140 svn_status = svn status "$@"
1141 git_status = git status "$@" || true
1142 bzr_status = bzr status "$@"
1143 cvs_status = cvs status "$@"
1144 hg_status  = hg status "$@"
1145 darcs_status = darcs whatsnew -ls "$@"
1146
1147 svn_commit = svn commit "$@"
1148 git_commit = git commit -a "$@" && git push --all
1149 bzr_commit = bzr commit "$@" && bzr push
1150 cvs_commit = cvs commit "$@"
1151 hg_commit  = hg commit -m "$@" && hg push
1152 darcs_commit = darcs commit -a -m "$@" && darcs push -a
1153
1154 svn_diff = svn diff "$@"
1155 git_diff = git diff "$@"
1156 bzr_diff = bzr diff "$@"
1157 cvs_diff = cvs diff "$@"
1158 hg_diff  = hg diff "$@"
1159 darcs_diff = darcs diff "$@"
1160
1161 svn_log = svn log "$@"
1162 git_log = git log "$@"
1163 bzr_log = bzr log "$@"
1164 cvs_log = cvs log "$@"
1165 hg_log  = hg log "$@"
1166 darcs_log = darcs changes "$@"
1167 git_bare_log = git log "$@"
1168
1169 svn_register =
1170         url=$(LANG=C svn info . | grep -i ^URL: | cut -d ' ' -f 2)
1171         if [ -z "$url" ]; then
1172                 error "cannot determine svn url"
1173         fi
1174         echo "Registering svn url: $url in $MR_CONFIG"
1175         mr -c "$MR_CONFIG" config "`pwd`" checkout="svn co '$url' '$MR_REPO'"
1176 git_register = 
1177         url="$(LANG=C git-config --get remote.origin.url)" || true
1178         if [ -z "$url" ]; then
1179                 error "cannot determine git url"
1180         fi
1181         echo "Registering git url: $url in $MR_CONFIG"
1182         mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone '$url' '$MR_REPO'"
1183 bzr_register =
1184         url=$(cat .bzr/branch/parent)
1185         if [ -z "$url" ]; then
1186                 error "cannot determine bzr url"
1187         fi
1188         echo "Registering bzr url: $url in $MR_CONFIG"
1189         mr -c "$MR_CONFIG" config "`pwd`" checkout="bzr clone '$url' '$MR_REPO'"
1190 cvs_register =
1191         repo=$(cat CVS/Repository)
1192         root=$(cat CVS/Root)
1193         if [ -z "$root" ]; then
1194                 error "cannot determine cvs root"
1195                 fi
1196         echo "Registering cvs repository $repo at root $root"
1197         mr -c "$MR_CONFIG" config "`pwd`" checkout="cvs -d '$root' co -d '$MR_REPO' '$repo'"
1198 hg_register = 
1199         url=$(hg showconfig paths.default)
1200         echo "Registering mercurial repo url: $url in $MR_CONFIG"
1201         mr -c "$MR_CONFIG" config "`pwd`" checkout="hg clone '$url' '$MR_REPO'"
1202 darcs_register = 
1203         url=$(cat _darcs/prefs/defaultrepo)
1204         echo "Registering darcs repository $url in $MR_CONFIG"
1205         mr -c "$MR_CONFIG" config "`pwd`" checkout="darcs get '$url'p '$MR_REPO'"
1206 git_bare_register = 
1207         url="$(LANG=C GIT_CONFIG=config git-config --get remote.origin.url)" || true
1208         if [ -z "$url" ]; then
1209                 error "cannot determine git url"
1210         fi
1211         echo "Registering git url: $url in $MR_CONFIG"
1212         mr -c "$MR_CONFIG" config "`pwd`" checkout="git clone --bare '$url' '$MR_REPO'"
1213
1214 help =
1215         if [ ! -e "$MR_PATH" ]; then
1216                 error "cannot find program path"
1217         fi
1218         (pod2man -c mr "$MR_PATH" | man -l -) || error "pod2man or man failed"
1219 list = true
1220 config = 
1221
1222 ed = echo "A horse is a horse, of course, of course.."
1223 T = echo "I pity the fool."
1224 right = echo "Not found."
1225 #}}}
1226
1227 # vim:sw=8:sts=0:ts=8:noet